unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls,LPTIO;

type
  TF_Glav = class(TForm)
    Timer1: TTimer;
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    Label12: TLabel;
    Lab1: TLabel;
    Scroll1: TScrollBar;
    Panel2: TPanel;
    Label1: TLabel;
    Lab4: TLabel;
    Scroll4: TScrollBar;
    Panel3: TPanel;
    Lab2: TLabel;
    Label14: TLabel;
    Scroll2: TScrollBar;
    Panel4: TPanel;
    Lab5: TLabel;
    Label4: TLabel;
    Scroll5: TScrollBar;
    Panel6: TPanel;
    Lab6: TLabel;
    Label17: TLabel;
    Scroll6: TScrollBar;
    Panel7: TPanel;
    Pan1: TPanel;
    Label7: TLabel;
    Panel10: TPanel;
    Label9: TLabel;
    Pan2: TPanel;
    Panel8: TPanel;
    Lab7: TLabel;
    Label3: TLabel;
    Scroll7: TScrollBar;
    Panel9: TPanel;
    Lab8: TLabel;
    Scroll8: TScrollBar;
    Label8: TLabel;
    Panel5: TPanel;
    Lab3: TLabel;
    Label6: TLabel;
    Scroll3: TScrollBar;
    Panel11: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Panel12: TPanel;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    Panel13: TPanel;
    Label2: TLabel;
    Panel14: TPanel;
    Panel15: TPanel;
    Label5: TLabel;
    Panel16: TPanel;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    GroupBox2: TGroupBox;
    Panel17: TPanel;
    Label10: TLabel;
    Lab9: TLabel;
    ScrollBar1: TScrollBar;
    Panel19: TPanel;
    Lab10: TLabel;
    Label18: TLabel;
    ScrollBar2: TScrollBar;
    Panel22: TPanel;
    Label23: TLabel;
    Panel23: TPanel;
    Panel26: TPanel;
    Lab12: TLabel;
    Label26: TLabel;
    ScrollBar4: TScrollBar;
    Panel28: TPanel;
    Lab11: TLabel;
    Label30: TLabel;
    ScrollBar3: TScrollBar;
    Panel29: TPanel;
    RadioBut2: TRadioButton;
    RadioBut3: TRadioButton;
    RadioBut4: TRadioButton;
    RadioBut1: TRadioButton;
    Panel31: TPanel;
    Label31: TLabel;
    Panel32: TPanel;
    Panel18: TPanel;
    Label11: TLabel;
    Panel20: TPanel;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
       Lpt : TLptPortConnection;
  public
    { Public declarations }
  end;

var
      F_Glav: TF_Glav;
      LPT_port:string[5];
      Byt_DS,Byt_AD:byte;
      pos_R1,pos_R2,pos_AD,pos_Tem1,pos_Tem2,pos_Tem_AD,pos_V1,pos_V_AD,
      pos_mA1,pos_V2,pos_mA2,pos_mA_AD: integer;
implementation

{$R *.dfm}

(***********************************)
(* -----Write data to CONTROL port of pc----- *)
procedure Write_control_port(port_data:byte);
begin
     if port_data and 1 =1 then port_data:=port_data and (255-1)
        else port_data:=port_data or 1;
     if port_data and 2 =2 then port_data:=port_data and (255-2)
        else port_data:=port_data or 2;
     if port_data and 8 =8 then port_data:=port_data and (255-8)
        else port_data:=port_data or 8;
        F_Glav.Lpt.WritePort (LPT2,2,port_data);
end;

(**********************************)
(* -----Read data into pc----- *)
Function Read_status_port:byte;
var
   byte1:byte;
begin
      byte1:=F_Glav.Lpt.ReadPort(LPT2,1) ;          (* read a byte from the status port *)
      byte1:=byte1 and 120;             (* 01111000 (MSB to LSB) and 0dddd... = 0dddd000 *)
      Read_status_port:=byte1 shr 3;    (* shift 3 bit right, Read_status_port = 0000hhhh *)
end;


(**********************************)
Function Bit_weight(bit:byte):byte;
var i,dummy:integer;
begin
if bit=1 then bit_weight:=1
       else
         begin
           dummy:=1;
             for i:=1 to bit-1 do dummy :=2*dummy;

             if dummy=0 then dummy :=1;
             bit_weight:=dummy;
         end;
end;

(**********************************)
procedure TF_Glav.FormDestroy(Sender: TObject);
begin
Write_control_port(0);
  Lpt.WritePort (LPT2,0,0);
  Lpt.Destroy;
   Close;
end;



(********** AD8400 ************************)
Procedure Potenc_AD(bit:byte);
begin
    Byt_AD:=0;                // sleep(1);
  F_Glav.Lpt.WritePort (LPT2,0,Byt_DS+Byt_AD);(* ClK=0, CS=0 *)
   Byt_AD:=0+bit*4;          //sleep(1);
  F_Glav.Lpt.WritePort (LPT2,0,Byt_DS+Byt_AD); (* ClK=0, CS=0, DQ= BYT) *)
   Byt_AD:=2+bit*4;            // sleep(1);
  F_Glav.Lpt.WritePort (LPT2,0,Byt_DS+Byt_AD); (* ClK=1, CS=0, DQ= BYT *)
  Byt_AD:=0;                  //   sleep(1);
  F_Glav.Lpt.WritePort (LPT2,0,Byt_DS+Byt_AD);   (* ClK=0, CS=0 *)    //  sleep(1);
end;

(**********************************)

(********** DS1267 ************************)
Procedure Potenc_DS(bit:byte);
begin
    Byt_DS:=8;       //   sleep(1);
  F_Glav.Lpt.WritePort (LPT2,0,Byt_DS+Byt_AD);(* ClK=0, CS=0 *)
    Byt_DS:=8+bit*32;      // sleep(1);
  F_Glav.Lpt.WritePort (LPT2,0,Byt_DS+Byt_AD); (* ClK=0, CS=0, DQ= BYT) *)
    Byt_DS:=8+16+bit*32;     //  sleep(1);
  F_Glav.Lpt.WritePort (LPT2,0,Byt_DS+Byt_AD); (* ClK=1, CS=0, DQ= BYT *)
    Byt_DS:=8;               // sleep(1);
  F_Glav.Lpt.WritePort (LPT2,0,Byt_DS+Byt_AD);   (* ClK=0, CS=0 *)
end;

(**********************************)
procedure potenciometr(R_DS1,R_DS2,R_AD:integer);
var i: integer;
begin

 (*----------------- AD8400 -------------------------*)

   Potenc_AD(0);
   Potenc_AD(0);

       for i:= 8 downto 1 do
         Potenc_AD(round((R_AD and Bit_weight(i))/Bit_weight(i)));

(*---------------------DS1267 -----------------------*)
   Potenc_DS(0);
   Potenc_DS(0);


       for i:= 8 downto 1 do
        Potenc_DS(round((R_DS1 and Bit_weight(i))/Bit_weight(i)));

       for i:= 8 downto 1 do
        Potenc_DS(round((R_DS2 and Bit_weight(i))/Bit_weight(i)));

       Byt_DS:=0;Byt_AD:=1;
       F_Glav.Lpt.WritePort (LPT2,0,Byt_DS+Byt_AD);(* ClK=0, CS=0 *)
end;

(**********************************)
Function Convert_R(X:real):real;
begin
   result:=(1.6187897e-10)*x*x*x*x*x*x*x - (2.0086667e-8)*x*x*x*x*x*x + (7.3727778e-7)*x*x*x*x*x +
  (1.0641667e-6)*x*x*x*x - (6.6888347e-4)*x*x*x + 0.0196994*x*x - 0.4624963*x + 8.9;
end;
(**********************************)

procedure TF_Glav.Timer1Timer(Sender: TObject);
  var R1,R2,R_AD:real;
 vih:real;
    i:byte;
    dat: array [1..10] of byte;
    Rez:real;

begin
     (***********    *********)

      Write_control_port(1);  (* Clock=0, -CS=1 *)
      Write_control_port(0);  (* Clock=0, -CS=0 *)

       for i:=1 to 10 do begin
        dat[i]:= Read_status_port  and 1;
      Write_control_port(0);   (* Clock=0, -CS=0 *)
      Write_control_port(2);  (* Clock=1, -CS=0 *)
      Write_control_port(0);  (* Clock=0, -CS=0 *)
                          end;

        Rez:=(512*dat[1] + 256*dat[2] +128*dat[3] + 64*dat[4]
        + 32*dat[5] + 16*dat[6] +8*dat[7] + 4*dat[8]
         + 2*dat[9]+1*dat[10]);


   F_Glav.Panel20.Caption:=formatFloat('0.0',(Rez));

   if RadioButton9.Checked=true then
   begin
      pos_R1:=round(Rez/4);
       potenciometr(pos_R1,pos_R2,pos_AD);
  end;


   if RadioButton10.Checked=true then
   begin
      pos_R2:=round(Rez/4);
       potenciometr(pos_R1,pos_R2,pos_AD);
  end;


   if RadioButton11.Checked=true then
   begin
      pos_AD:=round(Rez/4);
       potenciometr(pos_R1,pos_R2,pos_AD);
  end;



 (***********  _AD  *********)

(*-------------  ------------------------------*)
   if RadioBut1.Checked=true then
   begin
      pos_AD:=ScrollBar1.position;                  // _1
      F_Glav.Lab9.Caption:=IntToStr(pos_AD);
      pos_AD:=ScrollBar1.position;                  // _1

      potenciometr(pos_R1,pos_R2,pos_AD);
      R_AD:=pos_AD*0.039;
     end;

     (*------------- ------------------------------*)
   if RadioBut4.Checked=true then
   begin
    pos_Tem_AD:=ScrollBar4.position;
    F_Glav.Lab12.Caption:=formatFloat('0.0',(pos_Tem_AD/10));
    R_AD:=Convert_R(pos_Tem_AD/10);
    F_Glav.Panel32.Caption:=formatFloat('0.0',(pos_Tem_AD/10));
    end;
 (*-------- -----------------------------------*)

    if RadioBut2.Checked=true then
   begin
    pos_V1:=ScrollBar2.position;
    F_Glav.Lab10.Caption:=formatFloat('0.0',(pos_V_AD/100));
    R_AD:=0.5*(pos_V1)-75;
    F_Glav.Panel32.Caption:=formatFloat('0.0',(R_AD));
    R_AD:=Convert_R(R_AD);
    end;

(*--------   -----------------------------------*)

    if RadioBut3.Checked=true then
   begin
    pos_mA_AD:=ScrollBar3.position;
    F_Glav.Lab11.Caption:=formatFloat('0.00',(pos_mA_AD/10));
    R_AD:=0.625*(pos_mA_AD)-50;
    F_Glav.Panel32.Caption:=formatFloat('0.0',(R_AD));
    R_AD:=Convert_R(R_AD);
    end;

     F_Glav.Panel23.Caption:=formatFloat('0.0000',R_AD);


  (**********************************)
 (***********  _DS1  *********)
  (**********************************)


(*-------------  ------------------------------*)
   if RadioButton7.Checked=true then
   begin

      pos_R1:=Scroll1.position;                  // _1
      F_Glav.Lab1.Caption:=IntToStr(pos_R1);
      R1:=pos_R1*0.195;
     potenciometr(pos_R1,pos_R2,pos_AD);
    end;

    (*------------- ------------------------------*)
   if RadioButton3.Checked=true then
   begin
    pos_Tem1:=Scroll7.position;
    F_Glav.Lab7.Caption:=formatFloat('0.0',(pos_Tem1/10));
    R1:=Convert_R(pos_Tem1/10);
    F_Glav.Panel14.Caption:=formatFloat('0.0',(pos_Tem1/10));
    end;
 (*-------- -----------------------------------*)

    if RadioButton1.Checked=true then
   begin
    pos_V1:=Scroll2.position;
    F_Glav.Lab2.Caption:=formatFloat('0.0',(pos_V1/100));
    R1:=0.5*(pos_V1)-75;
    F_Glav.Panel14.Caption:=formatFloat('0.0',(R1));
    R1:=Convert_R(R1);
    end;

(*--------   -----------------------------------*)

    if RadioButton2.Checked=true then
   begin
    pos_mA1:=Scroll3.position;
    F_Glav.Lab3.Caption:=formatFloat('0.00',(pos_mA1/10));
    R1:=0.625*(pos_mA1)-50;
    F_Glav.Panel14.Caption:=formatFloat('0.0',(R1));
    R1:=Convert_R(R1);
    end;

     F_Glav.Pan1.Caption:=formatFloat('0.0000',R1);

         (**************************************)
         (***********  _DS2  *********)
         (**************************************)

     (*-------------  ------------------------------*)
   if RadioButton8.Checked=true then
   begin
       pos_R2:=Scroll4.position;                 // _2
       F_Glav.Lab4.Caption:=IntToStr(pos_R2);
       R2:=pos_R2*0.195+0.03;
       potenciometr(pos_R1,pos_R2,pos_AD);
    end;


(*------------- ------------------------------*)
   if RadioButton6.Checked=true then
   begin
    pos_Tem2:=Scroll8.position;
    F_Glav.Lab8.Caption:=formatFloat('0.0',(pos_Tem2/10));
    R2:=Convert_R(pos_Tem2/10);
    F_Glav.Panel16.Caption:=formatFloat('0.0',(pos_Tem2/10));
    end;
 (*-------- -----------------------------------*)

    if RadioButton4.Checked=true then
   begin
    pos_V2:=Scroll5.position;
    F_Glav.Lab5.Caption:=formatFloat('0.0',(pos_V2/100));
    R2:=0.5*(pos_V2)-75;
    F_Glav.Panel16.Caption:=formatFloat('0.0',(R2));
    R2:=Convert_R(R2);
    end;

(*--------   -----------------------------------*)

    if RadioButton5.Checked=true then
   begin
    pos_mA2:=Scroll6.position;
    F_Glav.Lab6.Caption:=formatFloat('0.00',(pos_mA2/10));
    R2:=0.625*(pos_mA2)-50;
    F_Glav.Panel16.Caption:=formatFloat('0.0',(R2));
    R2:=Convert_R(R2);
    end;

     F_Glav.Pan2.Caption:=formatFloat('0.0000',R2);

     (*------------- ------------------------------*)
// potenciometr(pos_R1,pos_R2,pos_AD);
end;

(**********************************)
procedure TF_Glav.FormCreate(Sender: TObject);
var msg : AnsiString;
begin

Lpt := TLptPortConnection.Create;
 if not Lpt.Ready then
  begin {    --    }
  msg := '    Lpt,   ERROR,   = ' + IntToStr(GetLastError());
  Application.MessageBox(PChar(msg),'ERROR',MB_OK);
  Application.Terminate; // 

end;
  F_Glav.Timer1.Enabled:=true;
  Byt_DS:=0;Byt_AD:=1;
  F_Glav.Lpt.WritePort (LPT2,0,Byt_DS+Byt_AD);

end;
(**********************************)

end.
