#include <pic.h>
static volatile bit Clk_AD      @ (unsigned)&PORTB*8+7;
static volatile bit Data_AD     @ (unsigned)&PORTB*8+6;

static volatile bit CS_AD5      @ (unsigned)&PORTB*8+4;
static volatile bit CS_AD4      @ (unsigned)&PORTB*8+5;
static volatile bit CS_AD3      @ (unsigned)&PORTA*8+0;// RA0
static volatile bit CS_AD2      @ (unsigned)&PORTA*8+1;// RA1
static volatile bit CS_AD1      @ (unsigned)&PORTA*8+2;// RA2

static volatile bit CLK_ACP     @ (unsigned)&PORTD*8+2;//1  RA0
static volatile bit Dat_ACP     @ (unsigned)&PORTC*8+4;//16  RA4

static volatile bit CS_ACP5     @ (unsigned)&PORTC*8+6;//8  // RA3
static volatile bit CS_ACP4     @ (unsigned)&PORTC*8+5;//4  // RA2
static volatile bit CS_ACP3     @ (unsigned)&PORTD*8+3;//2  // RA1
static volatile bit CS_ACP2     @ (unsigned)&PORTD*8+1;//128// RA7
static volatile bit CS_ACP1     @ (unsigned)&PORTD*8+0;//64  //RA6


 unsigned int dat1,dat2,dat3,dat4,dat5,temp_acp,acp1;
	__CONFIG(0x03F73);	
					

//***********************************************
unsigned int calibr( int j){
unsigned	int i;
if (j<10) { j=10;};
	switch(j) {

//////////////////////////////////////////////////		
case 10	: i=	2	; break;	// 	-25,0
case 11	: i=	4	; break;	//	-24,9
case 12	: i=	10	; break;	//	-24,8
case 13	: i=	16	; break;	//	-24,7
case 14	: i=	24	; break;	//	-24,6
case 15	: i=	33	; break;	//	-24,4
case 16	: i=	39	; break;	//	-24,3
case 17	: i=	44	; break;	//	-24,2
case 18	: i=	50	; break;	//	-24,1
case 19	: i=	56	; break;	//	-24,0
case 20	: i=	61	; break;	//	-23,9
case 21	: i=	70	; break;	//	-23,8
case 22	: i=	78	; break;	//	-23,6
case 23	: i=	83	; break;	//	-23,5
case 24	: i=	89	; break;	//	-23,4
case 25	: i=	94	; break;	//	-23,3
case 26	: i=	100	; break;	//	-23,2
case 27	: i=	105	; break;	//	-23,1
case 28	: i=	113	; break;	//	-23,0
case 29	: i=	121	; break;	//	-22,8
case 30	: i=	126	; break;	//	-22,7
case 31	: i=	131	; break;	//	-22,6
case 32	: i=	137	; break;	//	-22,5
case 33	: i=	142	; break;	//	-22,4
case 34	: i=	147	; break;	//	-22,3
case 35	: i=	152	; break;	//	-22,2
case 36	: i=	160	; break;	//	-22,1
case 37	: i=	167	; break;	//	-21,9
case 38	: i=	172	; break;	//	-21,8
case 39	: i=	177	; break;	//	-21,7
case 40	: i=	182	; break;	//	-21,6
case 41	: i=	187	; break;	//	-21,5
case 42	: i=	192	; break;	//	-21,4
case 43	: i=	199	; break;	//	-21,3
case 44	: i=	206	; break;	//	-21,1
case 45	: i=	211	; break;	//	-21,0
case 46	: i=	215	; break;	//	-20,9
case 47	: i=	220	; break;	//	-20,8
case 48	: i=	225	; break;	//	-20,7
case 49	: i=	229	; break;	//	-20,6
case 50	: i=	236	; break;	//	-20,5
case 51	: i=	243	; break;	//	-20,3
case 52	: i=	248	; break;	//	-20,2
case 53	: i=	252	; break;	//	-20,1
case 54	: i=	257	; break;	//	-20,0
case 55	: i=	261	; break;	//	-19,9
case 56	: i=	265	; break;	//	-19,8
case 57	: i=	270	; break;	//	-19,7
case 58	: i=	276	; break;	//	-19,6
case 59	: i=	283	; break;	//	-19,4
case 60	: i=	287	; break;	//	-19,3
case 61	: i=	291	; break;	//	-19,2
case 62	: i=	296	; break;	//	-19,1
case 63	: i=	300	; break;	//	-19,0
case 64	: i=	304	; break;	//	-18,9
case 65	: i=	310	; break;	//	-18,8
case 66	: i=	316	; break;	//	-18,6
case 67	: i=	320	; break;	//	-18,5
case 68	: i=	324	; break;	//	-18,4
case 69	: i=	328	; break;	//	-18,3
case 70	: i=	332	; break;	//	-18,2
case 71	: i=	336	; break;	//	-18,1
case 72	: i=	342	; break;	//	-18,0
case 73	: i=	348	; break;	//	-17,8
case 74	: i=	352	; break;	//	-17,7
case 75	: i=	356	; break;	//	-17,6
case 76	: i=	360	; break;	//	-17,5
case 77	: i=	363	; break;	//	-17,4
case 78	: i=	367	; break;	//	-17,3
case 79	: i=	371	; break;	//	-17,2
case 80	: i=	376	; break;	//	-17,1
case 81	: i=	382	; break;	//	-16,9
case 82	: i=	386	; break;	//	-16,8
case 83	: i=	389	; break;	//	-16,7
case 84	: i=	393	; break;	//	-16,6
case 85	: i=	396	; break;	//	-16,5
case 86	: i=	400	; break;	//	-16,4
case 87	: i=	405	; break;	//	-16,3
case 88	: i=	410	; break;	//	-16,1
case 89	: i=	414	; break;	//	-16,0
case 90	: i=	417	; break;	//	-15,9
case 91	: i=	421	; break;	//	-15,8
case 92	: i=	424	; break;	//	-15,7
case 93	: i=	428	; break;	//	-15,6
case 94	: i=	433	; break;	//	-15,5
case 95	: i=	438	; break;	//	-15,3
case 96	: i=	441	; break;	//	-15,2
case 97	: i=	444	; break;	//	-15,1
case 98	: i=	448	; break;	//	-15,0
case 99	: i=	451	; break;	//	-14,9
case 100: i=	454	; break;	//	-14,8
case 101: i=	457	; break;	//	-14,7
case 102: i=	462	; break;	//	-14,6
case 103: i=	467	; break;	//	-14,4
case 104: i=	470	; break;	//	-14,3
case 105: i=	473	; break;	//	-14,2
case 106: i=	476	; break;	//	-14,1
case 107: i=	479	; break;	//	-14,0
case 108: i=	482	; break;	//	-13,9
case 109: i=	487	; break;	//	-13,8
case 110: i=	491	; break;	//	-13,6
case 111: i=	494	; break;	//	-13,5
case 112: i=	497	; break;	//	-13,4
case 113: i=	500	; break;	//	-13,3
case 114: i=	503	; break;	//	-13,2
case 115: i=	506	; break;	//	-13,1
case 116: i=	510	; break;	//	-13,0
case 117: i=	514	; break;	//	-12,8
case 118: i=	517	; break;	//	-12,7
case 119: i=	520	; break;	//	-12,6
case 120: i=	523	; break;	//	-12,5
case 121: i=	525	; break;	//	-12,4
case 122: i=	528	; break;	//	-12,3
case 123: i=	531	; break;	//	-12,2
case 124: i=	535	; break;	//	-12,1
case 125: i=	539	; break;	//	-11,9
case 126: i=	542	; break;	//	-11,8
case 127: i=	544	; break;	//	-11,7
case 128: i=	547	; break;	//	-11,6
case 129: i=	550	; break;	//	-11,5
case 130: i=	552	; break;	//	-11,4
case 131: i=	556	; break;	//	-11,3
case 132: i=	560	; break;	//	-11,1
case 133: i=	562	; break;	//	-11,0
case 134: i=	565	; break;	//	-10,9
case 135: i=	567	; break;	//	-10,8
case 136: i=	570	; break;	//	-10,7
case 137: i=	572	; break;	//	-10,6
case 138: i=	576	; break;	//	-10,5
case 139: i=	580	; break;	//	-10,3
case 140: i=	582	; break;	//	-10,2
case 141: i=	585	; break;	//	-10,1
case 142: i=	587	; break;	//	-10,0
case 143: i=	589	; break;	//	-9,9
case 144: i=	592	; break;	//	-9,8
case 145: i=	594	; break;	//	-9,7
case 146: i=	598	; break;	//	-9,6
case 147: i=	601	; break;	//	-9,4
case 148: i=	603	; break;	//	-9,3
case 149: i=	606	; break;	//	-9,2
case 150: i=	608	; break;	//	-9,1
case 151: i=	610	; break;	//	-9,0
case 152: i=	612	; break;	//	-8,9
case 153: i=	616	; break;	//	-8,8
case 154: i=	619	; break;	//	-8,6
case 155: i=	621	; break;	//	-8,5
case 156: i=	623	; break;	//	-8,4
case 157: i=	625	; break;	//	-8,3
case 158: i=	628	; break;	//	-8,2
case 159: i=	630	; break;	//	-8,1
case 160: i=	633	; break;	//	-8,0
case 161: i=	636	; break;	//	-7,8
case 162: i=	638	; break;	//	-7,7
case 163: i=	640	; break;	//	-7,6
case 164: i=	642	; break;	//	-7,5
case 165: i=	644	; break;	//	-7,4
case 166: i=	646	; break;	//	-7,3
case 167: i=	648	; break;	//	-7,2
case 168: i=	651	; break;	//	-7,1
case 169: i=	654	; break;	//	-6,9
case 170: i=	656	; break;	//	-6,8
case 171: i=	658	; break;	//	-6,7
case 172: i=	660	; break;	//	-6,6
case 173: i=	662	; break;	//	-6,5
case 174: i=	664	; break;	//	-6,4
case 175: i=	667	; break;	//	-6,3
case 176: i=	670	; break;	//	-6,1
case 177: i=	671	; break;	//	-6,0
case 178: i=	673	; break;	//	-5,9
case 179: i=	675	; break;	//	-5,8
case 180: i=	677	; break;	//	-5,7
case 181: i=	679	; break;	//	-5,6
case 182: i=	682	; break;	//	-5,5
case 183: i=	684	; break;	//	-5,3
case 184: i=	686	; break;	//	-5,2
case 185: i=	688	; break;	//	-5,1
case 186: i=	690	; break;	//	-5,0
case 187: i=	691	; break;	//	-4,9
case 188: i=	693	; break;	//	-4,8
case 189: i=	695	; break;	//	-4,7
case 190: i=	697	; break;	//	-4,6
case 191: i=	700	; break;	//	-4,4
case 192: i=	702	; break;	//	-4,3
case 193: i=	703	; break;	//	-4,2
case 194: i=	705	; break;	//	-4,1
case 195: i=	707	; break;	//	-4,0
case 196: i=	708	; break;	//	-3,9
case 197: i=	711	; break;	//	-3,8
case 198: i=	713	; break;	//	-3,6
case 199: i=	715	; break;	//	-3,5
case 200: i=	717	; break;	//	-3,4
case 201: i=	718	; break;	//	-3,3
case 202: i=	720	; break;	//	-3,2
case 203: i=	721	; break;	//	-3,1
case 204: i=	724	; break;	//	-3,0
case 205: i=	726	; break;	//	-2,8
case 206: i=	728	; break;	//	-2,7
case 207: i=	729	; break;	//	-2,6
case 208: i=	731	; break;	//	-2,5
case 209: i=	732	; break;	//	-2,4
case 210: i=	734	; break;	//	-2,3
case 211: i=	735	; break;	//	-2,2
case 212: i=	737	; break;	//	-2,1
case 213: i=	740	; break;	//	-1,9
case 214: i=	741	; break;	//	-1,8
case 215: i=	743	; break;	//	-1,7
case 216: i=	744	; break;	//	-1,6
case 217: i=	746	; break;	//	-1,5
case 218: i=	747	; break;	//	-1,4
case 219: i=	749	; break;	//	-1,3
case 220: i=	751	; break;	//	-1,1
case 221: i=	753	; break;	//	-1,0
case 222: i=	754	; break;	//	-0,9
case 223: i=	755	; break;	//	-0,8
case 224: i=	757	; break;	//	-0,7
case 225: i=	758	; break;	//	-0,6
case 226: i=	760	; break;	//	-0,5
case 227: i=	762	; break;	//	-0,3
case 228: i=	764	; break;	//	-0,2
case 229: i=	765	; break;	//	-0,1
case 230: i=	766	; break;	//	0,0
case 231: i=	768	; break;	//	0,1
case 232: i=	769	; break;	//	0,2
case 233: i=	770	; break;	//	0,3
case 234: i=	772	; break;	//	0,5
case 235: i=	774	; break;	//	0,6
case 236: i=	775	; break;	//	0,7
case 237: i=	777	; break;	//	0,8
case 238: i=	778	; break;	//	0,9
case 239: i=	779	; break;	//	1,0
case 240: i=	780	; break;	//	1,1
case 241: i=	782	; break;	//	1,3
case 242: i=	784	; break;	//	1,4
case 243: i=	785	; break;	//	1,5
case 244: i=	787	; break;	//	1,6
case 245: i=	788	; break;	//	1,7
case 246: i=	789	; break;	//	1,8
case 247: i=	790	; break;	//	1,9
case 248: i=	792	; break;	//	2,1
case 249: i=	794	; break;	//	2,2
case 250: i=	795	; break;	//	2,3
case 251: i=	796	; break;	//	2,4
case 252: i=	797	; break;	//	2,5
case 253: i=	798	; break;	//	2,6
case 254: i=	799	; break;	//	2,7
case 255: i=	801	; break;	//	2,8
case 256: i=	802	; break;	//	3,0
case 257: i=	804	; break;	//	3,1
case 258: i=	805	; break;	//	3,2
case 259: i=	806	; break;	//	3,3
case 260: i=	807	; break;	//	3,4
case 261: i=	808	; break;	//	3,5
case 262: i=	809	; break;	//	3,6
case 263: i=	811	; break;	//	3,8
case 264: i=	813	; break;	//	3,9
case 265: i=	814	; break;	//	4,0
case 266: i=	815	; break;	//	4,1
case 267: i=	816	; break;	//	4,2
case 268: i=	817	; break;	//	4,3
case 269: i=	818	; break;	//	4,4
case 270: i=	819	; break;	//	4,6
case 271: i=	821	; break;	//	4,7
case 272: i=	822	; break;	//	4,8
case 273: i=	823	; break;	//	4,9
case 274: i=	824	; break;	//	5,0
case 275: i=	825	; break;	//	5,1
case 276: i=	826	; break;	//	5,2
case 277: i=	827	; break;	//	5,3
case 278: i=	828	; break;	//	5,5
case 279: i=	830	; break;	//	5,6
case 280: i=	831	; break;	//	5,7
case 281: i=	832	; break;	//	5,8
case 282: i=	833	; break;	//	5,9
case 283: i=	834	; break;	//	6,0
case 284: i=	834	; break;	//	6,1
case 285: i=	836	; break;	//	6,3
case 286: i=	837	; break;	//	6,4
case 287: i=	838	; break;	//	6,5
case 288: i=	839	; break;	//	6,6
case 289: i=	840	; break;	//	6,7
case 290: i=	841	; break;	//	6,8
case 291: i=	842	; break;	//	6,9
case 292: i=	843	; break;	//	7,1
case 293: i=	844	; break;	//	7,2
case 294: i=	845	; break;	//	7,3
case 295: i=	846	; break;	//	7,4
case 296: i=	847	; break;	//	7,5
case 297: i=	848	; break;	//	7,6
case 298: i=	849	; break;	//	7,7
case 299: i=	850	; break;	//	7,8
case 300: i=	851	; break;	//	8,0
case 301: i=	852	; break;	//	8,1
case 302: i=	853	; break;	//	8,2
case 303: i=	854	; break;	//	8,3
case 304: i=	855	; break;	//	8,4
case 305: i=	856	; break;	//	8,5
case 306: i=	856	; break;	//	8,6
case 307: i=	858	; break;	//	8,8
case 308: i=	859	; break;	//	8,9
case 309: i=	860	; break;	//	9,0
case 310: i=	860	; break;	//	9,1
case 311: i=	861	; break;	//	9,2
case 312: i=	862	; break;	//	9,3
case 313: i=	863	; break;	//	9,4
case 314: i=	864	; break;	//	9,6
case 315: i=	865	; break;	//	9,7
case 316: i=	866	; break;	//	9,8
case 317: i=	867	; break;	//	9,9
case 318: i=	867	; break;	//	10,0
case 319: i=	868	; break;	//	10,1
case 320: i=	869	; break;	//	10,2
case 321: i=	870	; break;	//	10,3
case 322: i=	871	; break;	//	10,5
case 323: i=	872	; break;	//	10,6
case 324: i=	873	; break;	//	10,7
case 325: i=	873	; break;	//	10,8
case 326: i=	874	; break;	//	10,9
case 327: i=	875	; break;	//	11,0
case 328: i=	875	; break;	//	11,1
case 329: i=	876	; break;	//	11,3
case 330: i=	878	; break;	//	11,4
case 331: i=	878	; break;	//	11,5
case 332: i=	879	; break;	//	11,6
case 333: i=	880	; break;	//	11,7
case 334: i=	880	; break;	//	11,8
case 335: i=	881	; break;	//	11,9
case 336: i=	882	; break;	//	12,1
case 337: i=	883	; break;	//	12,2
case 338: i=	884	; break;	//	12,3
case 339: i=	884	; break;	//	12,4
case 340: i=	885	; break;	//	12,5
case 341: i=	886	; break;	//	12,6
case 342: i=	886	; break;	//	12,7
case 343: i=	887	; break;	//	12,8
case 344: i=	888	; break;	//	13,0
case 345: i=	889	; break;	//	13,1
case 346: i=	890	; break;	//	13,2
case 347: i=	890	; break;	//	13,3
case 348: i=	891	; break;	//	13,4
case 349: i=	892	; break;	//	13,5
case 350: i=	892	; break;	//	13,6
case 351: i=	893	; break;	//	13,8
case 352: i=	894	; break;	//	13,9
case 353: i=	895	; break;	//	14,0
case 354: i=	895	; break;	//	14,1
case 355: i=	896	; break;	//	14,2
case 356: i=	897	; break;	//	14,3
case 357: i=	897	; break;	//	14,4
case 358: i=	898	; break;	//	14,6
case 359: i=	899	; break;	//	14,7
case 360: i=	900	; break;	//	14,8
case 361: i=	900	; break;	//	14,9
case 362: i=	901	; break;	//	15,0
case 363: i=	901	; break;	//	15,1
case 364: i=	902	; break;	//	15,2
case 365: i=	902	; break;	//	15,3
case 366: i=	903	; break;	//	15,5
case 367: i=	904	; break;	//	15,6
case 368: i=	905	; break;	//	15,7
case 369: i=	905	; break;	//	15,8
case 370: i=	906	; break;	//	15,9
case 371: i=	906	; break;	//	16,0
case 372: i=	907	; break;	//	16,1
case 373: i=	908	; break;	//	16,3
case 374: i=	909	; break;	//	16,4
case 375: i=	909	; break;	//	16,5
case 376: i=	910	; break;	//	16,6
case 377: i=	910	; break;	//	16,7
case 378: i=	911	; break;	//	16,8
case 379: i=	911	; break;	//	16,9
case 380: i=	912	; break;	//	17,1
case 381: i=	913	; break;	//	17,2
case 382: i=	913	; break;	//	17,3
case 383: i=	914	; break;	//	17,4
case 384: i=	915	; break;	//	17,5
case 385: i=	915	; break;	//	17,6
case 386: i=	916	; break;	//	17,7
case 387: i=	916	; break;	//	17,8
case 388: i=	917	; break;	//	18,0
case 389: i=	918	; break;	//	18,1
case 390: i=	918	; break;	//	18,2
case 391: i=	919	; break;	//	18,3
case 392: i=	919	; break;	//	18,4
case 393: i=	920	; break;	//	18,5
case 394: i=	920	; break;	//	18,6
case 395: i=	921	; break;	//	18,8
case 396: i=	921	; break;	//	18,9
case 397: i=	922	; break;	//	19,0
case 398: i=	922	; break;	//	19,1
case 399: i=	923	; break;	//	19,2
case 400: i=	923	; break;	//	19,3
case 401: i=	924	; break;	//	19,4
case 402: i=	924	; break;	//	19,6
case 403: i=	925	; break;	//	19,7
case 404: i=	925	; break;	//	19,8
case 405: i=	926	; break;	//	19,9
case 406: i=	926	; break;	//	20,0
case 407: i=	927	; break;	//	20,1
case 408: i=	927	; break;	//	20,2
case 409: i=	928	; break;	//	20,3
case 410: i=	928	; break;	//	20,5
case 411: i=	929	; break;	//	20,6
case 412: i=	929	; break;	//	20,7
case 413: i=	930	; break;	//	20,8
case 414: i=	930	; break;	//	20,9
case 415: i=	930	; break;	//	21,0
case 416: i=	931	; break;	//	21,1
case 417: i=	931	; break;	//	21,3
case 418: i=	932	; break;	//	21,4
case 419: i=	932	; break;	//	21,5
case 420: i=	932	; break;	//	21,6
case 421: i=	933	; break;	//	21,7
case 422: i=	933	; break;	//	21,8
case 423: i=	933	; break;	//	21,9
case 424: i=	934	; break;	//	22,1
case 425: i=	934	; break;	//	22,2
case 426: i=	935	; break;	//	22,3
case 	427	:	i=	936	;	break;	//	22,4
case 	428	:	i=	936	;	break;	//	22,5
case 	429	:	i=	936	;	break;	//	22,6
case 	430	:	i=	937	;	break;	//	23
case 	431	:	i=	937	;	break;	//	23,1
case 	432	:	i=	938	;	break;	//	23,3
case 	433	:	i=	938	;	break;	//	23,4
case 	434	:	i=	938	;	break;	//	23,5
case 	435	:	i=	939	;	break;	//	23,6
case 	436	:	i=	940	;	break;	//	23,8
case 	437	:	i=	940	;	break;	//	23,9
case 	438	:	i=	940	;	break;	//	24
case 	439	:	i=	941	;	break;	//	24,1
case 	440	:	i=	941	;	break;	//	24,2
case 	441	:	i=	941	;	break;	//	24,3
case 	442	:	i=	942	;	break;	//	24,4
case 	443	:	i=	942	;	break;	//	24,6
case 	444	:	i=	943	;	break;	//	24,7
case 	445	:	i=	943	;	break;	//	24,8
case 	446	:	i=	943	;	break;	//	24,9
case 	447	:	i=	944	;	break;	//	25
case 	448	:	i=	944	;	break;	//	25,1
case 	449	:	i=	944	;	break;	//	25,2
case 	450	:	i=	945	;	break;	//	25,3
case 	451	:	i=	945	;	break;	//	25,5
case 	452	:	i=	946	;	break;	//	25,6
case 	453	:	i=	946	;	break;	//	25,7
case 	454	:	i=	946	;	break;	//	25,8
case 	455	:	i=	947	;	break;	//	25,9
case 	456	:	i=	947	;	break;	//	26
case 	457	:	i=	948	;	break;	//	26,1
case 	458	:	i=	948	;	break;	//	26,3
case 	459	:	i=	948	;	break;	//	26,4
case 	460	:	i=	949	;	break;	//	26,5
case 	461	:	i=	949	;	break;	//	26,6
case 	462	:	i=	949	;	break;	//	26,7
case 	463	:	i=	950	;	break;	//	26,8
case 	464	:	i=	950	;	break;	//	26,9
case 	465	:	i=	950	;	break;	//	27,1
case 	466	:	i=	951	;	break;	//	27,2
case 	467	:	i=	951	;	break;	//	27,3
case 	468	:	i=	952	;	break;	//	27,4
case 	469	:	i=	952	;	break;	//	27,5
case 	470	:	i=	952	;	break;	//	27,6
case 	471	:	i=	953	;	break;	//	27,7
case 	472	:	i=	953	;	break;	//	27,8
case 	473	:	i=	954	;	break;	//	28
case 	474	:	i=	954	;	break;	//	28,1
case 	475	:	i=	954	;	break;	//	28,2
case 	476	:	i=	954	;	break;	//	28,3
case 	477	:	i=	955	;	break;	//	28,4
case 	478	:	i=	955	;	break;	//	28,5
case 	479	:	i=	955	;	break;	//	28,6
case 	480	:	i=	956	;	break;	//	28,8
case 	481	:	i=	956	;	break;	//	28,9
case 	482	:	i=	956	;	break;	//	29
case 	483	:	i=	957	;	break;	//	29,1
case 	484	:	i=	957	;	break;	//	29,2
case 	485	:	i=	957	;	break;	//	29,3
case 	486	:	i=	958	;	break;	//	29,4
case 	487	:	i=	958	;	break;	//	29,6
case 	488	:	i=	958	;	break;	//	29,7
case 	489	:	i=	959	;	break;	//	29,8
case 	490	:	i=	959	;	break;	//	29,9
case 	491	:	i=	959	;	break;	//	30
case 	492	:	i=	959	;	break;	//	30,1
case 	493	:	i=	960	;	break;	//	30,2
case 	494	:	i=	960	;	break;	//	30,3
case 	495	:	i=	960	;	break;	//	30,5
case 	496	:	i=	961	;	break;	//	30,6
case 	497	:	i=	961	;	break;	//	30,7
case 	498	:	i=	961	;	break;	//	30,8
case 	499	:	i=	962	;	break;	//	30,9
case 	500	:	i=	962	;	break;	//	31
case 	501	:	i=	962	;	break;	//	31,1
case 	502	:	i=	963	;	break;	//	31,3
case 	503	:	i=	963	;	break;	//	31,4
case 	504	:	i=	963	;	break;	//	31,5
case 	505	:	i=	963	;	break;	//	31,6
case 	506	:	i=	964	;	break;	//	31,7
case 	507	:	i=	964	;	break;	//	31,8
case 	508	:	i=	964	;	break;	//	31,9
case 	509	:	i=	965	;	break;	//	32,1
case 	510	:	i=	965	;	break;	//	32,2
case 	511	:	i=	965	;	break;	//	32,3
case 	512	:	i=	966	;	break;	//	32,4
case 	513	:	i=	966	;	break;	//	32,5
case 	514	:	i=	966	;	break;	//	32,6
case 	515	:	i=	966	;	break;	//	32,7
case 	516	:	i=	967	;	break;	//	32,8
case 	517	:	i=	967	;	break;	//	33
case 	518	:	i=	967	;	break;	//	33,1
case 	519	:	i=	968	;	break;	//	33,2
case 	520	:	i=	968	;	break;	//	33,3
}; //  end  	switch

    return i;}

//***********************************************
unsigned int calibr1( int j){
unsigned	int i;

if (j>569) { j=569;};
	switch(j) {
			
/////////////////////////////////////////////////
case 	521	:	i=	968	;	break;	//	33,4
case 	522	:	i=	968	;	break;	//	33,5
case 	523	:	i=	969	;	break;	//	33,6
case 	524	:	i=	969	;	break;	//	33,8
case 	525	:	i=	969	;	break;	//	33,9
case 	526	:	i=	970	;	break;	//	34
case 	527	:	i=	970	;	break;	//	34,1
case 	528	:	i=	970	;	break;	//	34,2
case 	529	:	i=	970	;	break;	//	34,3
case 	530	:	i=	971	;	break;	//	34,4
case 	531	:	i=	971	;	break;	//	34,6
case 	532	:	i=	971	;	break;	//	34,7
case 	533	:	i=	971	;	break;	//	34,8
case 	534	:	i=	972	;	break;	//	34,9
case 	535	:	i=	972	;	break;	//	35
case 	536	:	i=	972	;	break;	//	35,1
case 	537	:	i=	972	;	break;	//	35,2
case 	538	:	i=	973	;	break;	//	35,3
case 	539	:	i=	973	;	break;	//	35,5
case 	540	:	i=	973	;	break;	//	35,6
case 	541	:	i=	973	;	break;	//	35,7
case 	542	:	i=	974	;	break;	//	35,8
case 	543	:	i=	974	;	break;	//	35,9
case 	544	:	i=	974	;	break;	//	36
case 	545	:	i=	975	;	break;	//	36,1
case 	546	:	i=	975	;	break;	//	36,3
case 	547	:	i=	975	;	break;	//	36,4
case 	548	:	i=	975	;	break;	//	36,5
case 	549	:	i=	975	;	break;	//	36,6
case 	550	:	i=	976	;	break;	//	36,7
case 	551	:	i=	976	;	break;	//	36,8
case 	552	:	i=	976	;	break;	//	36,9
case 	553	:	i=	976	;	break;	//	37,1
case 	554	:	i=	977	;	break;	//	37,2
case 	555	:	i=	977	;	break;	//	37,3
case 	556	:	i=	977	;	break;	//	37,4
case 	557	:	i=	978	;	break;	//	37,5
case 	558	:	i=	978	;	break;	//	37,6
case 	559	:	i=	978	;	break;	//	37,7
case 	560	:	i=	978	;	break;	//	37,8
case 561: i=	978	; break;	//	37,6
case 562: i=	979	; break;	//	37,7
case 563: i=	979	; break;	//	37,8
case 564: i=	979	; break;	//	38,0
case 565: i=	979	; break;	//	38,1
case 566: i=	979	; break;	//	38,2
case 567: i=	980	; break;	//	38,3
case 568: i=	980	; break;	//	38,4
case 569: i=	980	; break;	//	38,5

		             }; //  end  	switch
	             
	      
            return i;}

//****************   *******************************
unsigned int ACP(){
unsigned int i,Rez_ACP;
unsigned int dat[11];
 

 for (i=1; i<=10; i++) {

  CLK_ACP=0;
  CLK_ACP=1; 
  dat[i]=Dat_ACP;
  CLK_ACP=0;
}   

        Rez_ACP=(512*dat[1] + 256*dat[2] +128*dat[3] + 64*dat[4]
        + 32*dat[5] + 16*dat[6] +8*dat[7] + 4*dat[8]
         + 2*dat[9]+1*dat[10]);

         return Rez_ACP; }

 //(**********************************)
unsigned int Bit_weight(int byt){
unsigned int weight;

switch (byt){
  case 1:    weight=1;	break;
  case 2:    weight=2;	break;
  case 3:    weight=4;	break;
  case 4:    weight=8;	break;
  case 5:    weight=16;	break;
  case 6:    weight=32;	break;
  case 7:    weight=64;	break;
  case 8:    weight=128;	break;
  case 9:    weight=256;	break;
  case 10:   weight=512;	break;}
             return weight;}

  ///	(********** Potenciometr  AD5231*********************)
void; AD10(int byt)
{
   Clk_AD=0;     // ClK=0
   Data_AD=0;    // DQ=0
   Data_AD=byt;  // DQ= BYT
   Clk_AD=1;     // ClK=1
   Clk_AD=0;     // ClK=0
   Data_AD=0;}   // DQ=0


 //(**********************************)

void potenc(int byt){ 
unsigned int temp,i;

   AD10(1);
   AD10(0);
   AD10(1);
   AD10(1);
   
      for (i=10; i>0; i--) {AD10(0);}
	     
		for (i=10; i>0; i--) {
	      temp=Bit_weight(i);
	      AD10(( byt & Bit_weight(i))/(temp));}}


//	(********** GLAV ************************)

void main(void){				
   OPTION = 71;				
   TMR0 = 0;			
   T0IE = 0;			
   GIE = 0;			
   INTCON=0;
   TMR1ON = 0;		
   TMR1CS=0;
   ADCON1=6;
   PSPMODE=0;//  D 
   SSPEN=0;
   TRISA=0;
   TRISB=0;		
   TRISC=16;
   TRISD=0;
   
	 	while (1 == 1) {		


//(*--------------------AD5231 ----- 1 ------------------*)
 
    CS_ACP1=0;  //  1
    temp_acp=ACP();
if (440>temp_acp) { temp_acp=440; };
if (999<temp_acp) { temp_acp=999; };
    temp_acp=temp_acp-426;  
if (temp_acp<521) {  dat1=calibr (temp_acp); };  
if (temp_acp>520) {  dat1=calibr1(temp_acp); };  
    CS_ACP1=1; //   1  
 	
	PORTA=3;
    potenc(dat1); 
  	PORTA=7;
	      
 //(*---------------------AD5231 ------ 2 -----------------*)

      CS_ACP2=0;//  2
      temp_acp=ACP();
  if (440>temp_acp) { temp_acp=440; };
if (999<temp_acp) { temp_acp=999; };
      temp_acp=temp_acp-426;  
  if (temp_acp<521) {  dat2=calibr(temp_acp); };  
  if (temp_acp>520) {  dat2=calibr1(temp_acp); };  
      CS_ACP2=1; //   1   
 
      PORTA=5;
      potenc(dat2); 
      PORTA=7;
//(*---------------------AD5231 -------- 3 ---------------*)

      CS_ACP3=0; //  3
      temp_acp=ACP();
  if (440>temp_acp) { temp_acp=440; };
if (999<temp_acp) { temp_acp=999; };
      temp_acp=temp_acp-426;  
  if (temp_acp<521) {  dat3=calibr(temp_acp); };  
  if (temp_acp>520) {  dat3=calibr1(temp_acp); };  
      CS_ACP3=1; //   1 
  
      PORTA=6;
      potenc(dat3); 

      PORTA=7;
 //(*---------------------AD5231 ------- 4 ----------------*)

      CS_ACP4=0;//  4
      temp_acp=ACP();
  if (440>temp_acp) { temp_acp=440; };
if (999<temp_acp) { temp_acp=999; };
      temp_acp=temp_acp-426;  
  if (temp_acp<521) {  dat4=calibr(temp_acp); };  
  if (temp_acp>520) {  dat4=calibr1(temp_acp); };  
      CS_ACP4=1; //   1  
  
      CS_AD4=0;
      potenc(dat4); 
      CS_AD4=1; 
  	
 //(*---------------------AD5231 ------- 5 ----------------*)

      CS_ACP5=0;//  5
      temp_acp=ACP();
  if (440>temp_acp) { temp_acp=440; };
if (999<temp_acp) { temp_acp=999; };
      temp_acp=temp_acp-426;  
  if (temp_acp<521) {  dat5=calibr(temp_acp); };  
  if (temp_acp>520) {  dat5=calibr1(temp_acp); };  
      CS_ACP5=1; //   1  
  
	  CS_AD5=0;
      potenc(dat5); 
  	  CS_AD5=1;  
      
  	}  //  endwhile

}  //  End of Mainline

