#include <pic.h>
///#include<p16f627.inc>
static volatile bit Clk_AD      @ (unsigned)&PORTB*8+0;
static volatile bit Data_AD     @ (unsigned)&PORTB*8+1;

static volatile bit CS_AD5      @ (unsigned)&PORTB*8+2;
static volatile bit CS_AD4      @ (unsigned)&PORTB*8+3;
static volatile bit CS_AD3      @ (unsigned)&PORTB*8+4;
static volatile bit CS_AD2      @ (unsigned)&PORTB*8+5;
static volatile bit CS_AD1      @ (unsigned)&PORTB*8+6;

static volatile bit CLK_ACP     @ (unsigned)&PORTA*8+0;//1  RA0
static volatile bit Dat_ACP     @ (unsigned)&PORTA*8+4;//16  RA4

static volatile bit CS_ACP5     @ (unsigned)&PORTA*8+3;//8  // RA3
static volatile bit CS_ACP4     @ (unsigned)&PORTA*8+2;//4  // RA2
static volatile bit CS_ACP3     @ (unsigned)&PORTA*8+1;//2  // RA1
static volatile bit CS_ACP2     @ (unsigned)&PORTA*8+7;//128// RA7
static volatile bit CS_ACP1     @ (unsigned)&PORTA*8+6;//64  //RA6


 unsigned int dat1,dat2,dat3,dat4,dat5;

//bank1 
// unsigned int CLK_ACP=0;
//bank1
// unsigned int Dat_ACP=4;
	__CONFIG(0x03F70);		//  PIC116F627 Configuration Fuses:
					

//****************   *******************************
unsigned int ACP(){
unsigned int i,Rez_ACP;
unsigned int dat[10];
 

 for (i=1; i<=10; i++) {

 #asm
   bcf 5,0;//CLK_ACP;
   bsf 5,0;//PORTA,CLK_ACP
    bcf 5,0;//CLK_ACP;
    
#endasm
//  CLK_ACP=0;
  // CLK_ACP=1; 
//   dat[i]=Dat_ACP;
  // CLK_ACP=0;
}   

        Rez_ACP=(512*dat[1] + 256*dat[2] +128*dat[3] + 64*dat[4]
        + 32*dat[5] + 16*dat[6] +8*dat[7] + 4*dat[8]
         + 2*dat[9]+1*dat[10]);

         return Rez_ACP; }


  ///	(********** Potenciometr  AD5231*********************)
void; AD10(int byt)
{
   Clk_AD=0;     // ClK=0
   Data_AD=0;    // DQ=0
   Data_AD=byt;  // DQ= BYT
   Clk_AD=1;     // ClK=1
   Clk_AD=0;     // ClK=0
   Data_AD=0;}   // DQ=0

 //(**********************************)
unsigned int Bit_weight(int byt){
unsigned int weight;

switch (byt){
  case 1:    weight=1;	break;
  case 2:    weight=2;	break;
  case 3:    weight=4;	break;
  case 4:    weight=8;	break;
  case 5:    weight=16;	break;
  case 6:    weight=32;	break;
  case 7:    weight=64;	break;
  case 8:    weight=128;	break;
  case 9:    weight=256;	break;
  case 10:   weight=512;	break;}
             return weight;}

 //(**********************************)

void potenc(int byt){ 
unsigned int temp,i;

   AD10(1);
   AD10(0);
   AD10(1);
   AD10(1);
   
      for (i=10; i>0; i--) {AD10(0);}
	     
		for (i=10; i>0; i--) {
	      temp=Bit_weight(i);
	      AD10(( byt & Bit_weight(i))/(temp));}}



//***********************************************
unsigned int calibr( int j){
unsigned	int i;

	switch(j) {
			
/////////////////////////////////////////////////
//////////////////////////////////////////////////		
			case 30:	i=72; break;	//  -8
         case 31:	i=76; break;		
			case 32:	i=78; break;		
			case 33:	i=80; break;
   	   case 34:	i=82; break;		
			case 35:	i=84; break;		
			case 36:	i=86; break;	
         case 37:	i=88; break;		
			case 38:	i=92; break;		
			case 39:	i=94; break;		
			case 40:	i=96; break;		
			case 41:	i=98; break;	
			case 42:	i=100; break;		
			case 43:	i=102; break;		
			case 44:	i=104; break;	
			case 45:	i=108; break;		
			case 46:	i=110; break;	
		   case 47:	i=111; break;		
			case 48:	i=113; break;		
			case 49:	i=115; break;		
			case 50:	i=117; break;		
			case 51:	i=119; break;		
	      case 52:	i=121; break;
         case 53:	i=124; break;		
			case 54:	i=126; break;		
			case 55:	i=128; break;		
			case 56:	i=130; break;		
			case 57:	i=131; break;		
			case 58:	i=133; break;	
         case 59:	i=135; break;		
			case 60:	i=138; break;		
			case 61:	i=140; break;		
			case 62:	i=142; break;		
			case 63:	i=143; break;		
			case 64:	i=145; break;	
         case 65:	i=147; break;		
			case 66:	i=148; break;		
			case 67:	i=152; break;		
			case 68:	i=153; break;		
			case 69:	i=155; break;	
			case 70:	i=157; break;	
         case 71:	i=158; break;		
			case 72:	i=160; break;		
			case 73:	i=161; break;		
			case 74:	i=163; break;		
			case 75:	i=166; break;		
		   case 76:	i=168; break;	
         case 77:	i=169; break;		
			case 78:	i=171; break;		
			case 79:	i=172; break;		
			case 80:	i=174; break;		
			case 81:	i=175; break;		
			case 82:	i=178; break;	
         case 83:	i=180; break;		
			case 84:	i=181; break;		
			case 85:	i=183; break;		
			case 86:	i=184; break;		
			case 87:	i=186; break;		
			case 88:	i=187; break;
         case 89:	i=190; break;
       	case 90:	i=191; break;			
			case 91:	i=193; break;		
			case 92:	i=194; break;		
			case 93:	i=195; break;		
			case 94:	i=197; break;
		   case 95:	i=198; break;
			case 96:	i=201; break;			
			case 97:	i=202; break;			
			case 98:	i=204; break;			
			case 99:	i=205; break;
	      case 100:	i=206; break;  
	     	case 101:	i=208; break;		
			case 102:	i=209; break;			
			case 103:	i=210; break;
			case 104:	i=213; break;
			case 105:	i=214; break;		
			case 106:	i=215; break;		
			case 107:	i=217; break;
	      case 108:	i=218; break;
			case 109:	i=219; break;		
			case 110:	i=220; break;		
			case 111:	i=223; break;		
	    	case 112:	i=224; break;		
			case 113:	i=225; break;
	      case 114:	i=227; break;
			case 115:	i=228; break;
		   case 116:	i=229; break;
			case 117:	i=230; break;		
			case 118:	i=231; break;		
			case 119:	i=234; break;	
         case 120:	i=235; break;
		   case 121:	i=236; break;
			case 122:	i=237; break;		
			case 123:	i=238; break;		
			case 124:	i=239; break;		
	      case 125:	i=241; break;
	      case 126:	i=243; break;
			case 127:	i=244; break;	
         case 128:	i=245; break;		
			case 129:	i=246; break;
         case 130:	i=247; break;
			case 131:	i=248; break;
        	case 132:	i=249; break;		
			case 133:	i=250; break;	
			case 134:	i=253; break;
			case 135:	i=254; break;
	      case 136:	i=255; break;
	      case 137:	i=256; break;
	      case 138:	i=257; break; 
			case 139:	i=258; break;
	      case 140:	i=259; break; 
			case 141:	i=261; break;		
			case 142:	i=262; break;
         case 143:	i=263; break;
			case 144:	i=264; break;
	      case 145:	i=265; break;
			case 146:	i=266; break;
		   case 147:	i=267; break;
			case 148:	i=269; break;
	      case 149:	i=270; break;
			case 150:	i=271; break;	
			case 151:	i=272; break;
		   case 152:	i=273; break; 
			case 153:	i=274; break;	
			case 154:	i=274; break;	
		   case 155:	i=275; break;
		   case 156:	i=277; break;
		   case 157:	i=278; break;
			case 158:	i=279; break;		
			case 159:	i=280; break;
         case 160:	i=281; break;   
		   case 161:	i=282; break;
		   case 162:	i=283; break;		
	     	case 163:	i=284; break;
        	case 164:	i=285; break;		
			case 165:	i=286; break;		
			case 166:	i=287; break;		
			case 167:	i=288; break;		
			case 168:	i=289; break;	
         case 169:	i=290; break;		
			case 170:	i=291; break;		
			case 171:	i=292; break;		
			case 172:	i=293; break;		
			case 173:	i=294; break;
         case 174:	i=295; break;	
        case 175:	i=296; break;	
         case 176:	i=296; break;	        	        	
			case 177:	i=297; break;  //   8.7
      
		             }; //  end  	switch
	             
	       if (j<30) { i=30;};
		    if (j>177) { i=299;};   
            return i;}

//	(********** GLAV ************************)

void main(void){				
	OPTION = 71;				
   TMR0 = 0;			
	T0IE = 0;			
	GIE = 0;			
   CMCON=0x007;
   INTCON=0;
	TMR1ON = 0;		
	TMR1CS=0;			
   VRCON=0;		
   TRISA=16;
   TRISB=0;
  
 
	 	while (1 == 1) {		
//(*--------------------AD5231 ----- 1 ------------------*)
 
 
   CS_ACP1=0;  //  1
   dat1=(calibr(ACP()-559)); 
   PORTA=206; //   1  
	
	CS_AD1=0;
   potenc( dat1+560); 
  	PORTB=124;
	      
 //(*---------------------AD5231 ------ 2 -----------------*)

   CS_ACP2=0;//  2
   dat2=(calibr(ACP()-561));
   PORTA=206; //   1   
 
   CS_AD2=0;
   potenc( dat2+560); 
   PORTB=124;

//(*---------------------AD5231 -------- 3 ---------------*)

   CS_ACP3=0; //  3
   dat3=(calibr(ACP()-561));
   PORTA=206; //   1 
  
	CS_AD3=0;
   potenc( dat3+560); 
  	PORTB=124;
 //(*---------------------AD5231 ------- 4 ----------------*)

   CS_ACP4=0;//  4
    dat4=(calibr(ACP()-559));
   PORTA=206; //   1  
  
	CS_AD4=0;
   potenc( dat4+560); 
  	PORTB=124; 
  	
 //(*---------------------AD5231 ------- 5 ----------------*)

   CS_ACP5=0;//  5
   dat5=(calibr(ACP()-561));
   PORTA=206; //   1  
  
	CS_AD5=0;
   potenc( dat5+560); 
  	PORTB=124; 
  	}  //  endwhile

}  //  End of Mainline

